package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	INFO            = "info"
	TYPE            = "type"
	ROLE            = "role"
	TOTAL           = "total"
	STOCK           = "stock"
	PRICE           = "price"
	SPACE           = "space"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_CLOUD_ROLE = "user_cloud_role"
	CLOUD_UID       = "cloud_uid"
	CLOUD_TYPE      = "cloud_type"
	CLUSTER_UID     = "cluster_uid"
	CLUSTER_SPACE   = "cluster_space"
	GATEWAY_UID     = "gateway_uid"
	GATEWAY_SPACE   = "gateway_space"
	PROJECT_UID     = "project_uid"
	PROJECT_NAME    = "project_name"
)

type UserCloud struct {
	db.ModelUserPlace
	CloudUID string `gorm:"type:char(32);index"`
}
type Cloud struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Cluster struct {
	db.ModelContent
	Space string `gorm:"type:varchar(64);index"`
	Total int
	Stock int
	Price int
}
type Gateway struct {
	db.ModelContent
	Space      string `gorm:"type:varchar(64)"`
	CloudUID   string `gorm:"type:char(32);index"`
	ClusterUID string `gorm:"type:char(32);index"`
}
type Project struct {
	db.ModelNameInfo
	Repos      string `gorm:"type:varchar(255)"`
	Binary     string `gorm:"type:varchar(255)"`
	CloudUID   string `gorm:"type:char(32);index"`
	GatewayUID string `gorm:"type:char(32);index"`
}
type Product struct {
	db.ModelNameInfo
	Icon       string `gorm:"type:varchar(255)"`
	Index      string `gorm:"type:varchar(128)"`
	CloudUID   string `gorm:"type:char(32);index"`
	ProjectUID string `gorm:"type:char(32);index"`
}

func init() { db.CmdModels("", &UserCloud{}, &Cloud{}, &Cluster{}, &Gateway{}, &Project{}, &Product{}) }
